"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var react_1 = __importDefault(require("react"));
var hooks_1 = require("@steroidsjs/core/hooks");
var typography_1 = require("@steroidsjs/core/ui/typography");
var form_1 = require("@steroidsjs/core/ui/form");
var nav_1 = require("@steroidsjs/core/ui/nav");
var DEFAULT_AXIS_PARAMS = {
    tickSize: 5,
    tickPadding: 5,
    tickRotation: 0,
    legend: '',
    legendPosition: 'middle'
};
var DEFAULT_LINE_CHART_CONFIG = {
    yScale: {
        type: 'linear',
        min: 'auto',
        max: 'auto',
        stacked: true,
        reverse: false
    },
    xScale: { type: 'point' },
    axisBottom: __assign(__assign({}, DEFAULT_AXIS_PARAMS), { legendOffset: 36 }),
    axisLeft: __assign(__assign({}, DEFAULT_AXIS_PARAMS), { legendOffset: -40 }),
    pointSize: 8,
    useMesh: true
};
function ChartView(props) {
    var bem = (0, hooks_1.useBem)('ChartView');
    var ChartComponent = props.chartComponent;
    var defaultChartConfig = (props.useDefaultLineChartConfig && DEFAULT_LINE_CHART_CONFIG) || {};
    var customChartHeightVariable = { '--chart-custom-height': "".concat(props.chartHeight, "px") };
    return (react_1["default"].createElement("div", { className: bem(bem.block(), props.className), style: __assign(__assign(__assign({}, props.style), { height: "".concat(props.wrapperHeight, "px") }), customChartHeightVariable) },
        props.title && (react_1["default"].createElement(typography_1.Title, { type: "h3", content: props.title, className: bem.element('title') })),
        react_1["default"].createElement("div", { className: bem.element('controls') },
            props.checkboxes && (react_1["default"].createElement(form_1.CheckboxListField, __assign({}, props.checkboxes))),
            props.buttonGroup && (react_1["default"].createElement(nav_1.ButtonGroup, __assign({}, props.buttonGroup)))),
        react_1["default"].createElement(ChartComponent, __assign({ style: {
                height: "".concat(props.chartHeight, "px !important")
            }, data: props.data }, defaultChartConfig, props.config))));
}
exports["default"] = ChartView;
