"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var react_1 = __importDefault(require("react"));
var useBem_1 = __importDefault(require("@steroidsjs/core/hooks/useBem"));
var hooks_1 = require("@steroidsjs/core/hooks");
var TreeItemView_1 = __importDefault(require("../../nav/TreeItem/TreeItemView"));
function CheckboxTreeFieldView(props) {
    var bem = (0, useBem_1["default"])('CheckboxTreeFieldView');
    var prefix = (0, hooks_1.useUniqueId)('checkbox');
    return (react_1["default"].createElement("div", { className: bem.block() }, props.items.map(function (checkbox) { return (react_1["default"].createElement(TreeItemView_1["default"], { key: checkbox.uniqueId, item: checkbox, levelPadding: props.levelPadding, onNestedItemClick: function () { return props.onItemSelect(checkbox); }, hasIconExpandOnly: !props.hasOnlyLeafCheckboxes && checkbox.hasItems, withoutPointerOnLabel: props.hasOnlyLeafCheckboxes && checkbox.hasItems }, props.renderCheckbox({
        id: props.hasOnlyLeafCheckboxes && checkbox.hasItems ? null : "".concat(prefix, "_").concat(checkbox.id),
        label: checkbox.label,
        inputProps: {
            name: "".concat(prefix, "_").concat(checkbox.id),
            type: 'checkbox',
            checked: props.selectedIds.includes(checkbox.id),
            onChange: function () {
                props.onItemSelect(checkbox);
            },
            disabled: checkbox.disabled,
            required: checkbox.required
        },
        size: props.size,
        color: checkbox.color
    }))); })));
}
exports["default"] = CheckboxTreeFieldView;
